* finding or making overcommit--main--1.0--patch-34
* finding or making quotas--patch--1.0--patch-6
* auto-adding kostikbel@ukr.net--2005-freebsd/quotas--patch--1.0--patch-6 to greedy revision library /usr/home/kostik/tla-libraries
* found immediate ancestor revision in library (kostikbel@ukr.net--2005-freebsd/quotas--patch--1.0--patch-5)
* patching for this revision (kostikbel@ukr.net--2005-freebsd/quotas--patch--1.0--patch-6)
* computing changeset
A/ {arch}/quotas
A/ {arch}/quotas/quotas--patch
A/ {arch}/quotas/quotas--patch/quotas--patch--1.0
A/ {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd
A/ {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log
A  {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/base-0
A  {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-1
A  {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-2
A  {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-3
A  {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-4
A  {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-5
A  {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-6
M  sys/ufs/ffs/ffs_vfsops.c
M  sys/ufs/ufs/quota.h
M  sys/ufs/ufs/ufs_inode.c
M  sys/ufs/ufs/ufs_quota.c
M  sys/ufs/ufs/ufs_vnops.c
* changeset report
* added directories

    {arch}/quotas
    {arch}/quotas/quotas--patch
    {arch}/quotas/quotas--patch/quotas--patch--1.0
    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd
    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log

* added files

    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/base-0
    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-1
    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-2
    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-3
    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-4
    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-5
    {arch}/quotas/quotas--patch/quotas--patch--1.0/kostikbel@ukr.net--2005-freebsd/patch-log/patch-6

* modified files

--- orig/sys/ufs/ffs/ffs_vfsops.c
+++ mod/sys/ufs/ffs/ffs_vfsops.c
@@ -826,9 +826,7 @@
 	(void) ufs_extattr_autostart(mp, td);
 #endif /* !UFS_EXTATTR_AUTOSTART */
 #endif /* !UFS_EXTATTR */
-#ifndef QUOTA
 	mp->mnt_kern_flag |= MNTK_MPSAFE;
-#endif
 	return (0);
 out:
 	if (bp)
@@ -1020,6 +1018,7 @@
 {
 	struct ufsmount *ump;
 	int error;
+	int gianted = 0;
 
 	ump = VFSTOUFS(mp);
 #ifdef QUOTA
@@ -1028,11 +1027,15 @@
 		error = vflush(mp, 0, SKIPSYSTEM|flags, td);
 		if (error)
 			return (error);
+		if (!mtx_owned(&Giant)) {
+			mtx_lock(&Giant);
+			gianted = 1;
+		}
 		for (i = 0; i < MAXQUOTAS; i++) {
-			if (ump->um_quotas[i] == NULLVP)
-				continue;
 			quotaoff(td, mp, i);
 		}
+		if (gianted)
+			mtx_unlock(&Giant);
 		/*
 		 * Here we fall through to vflush again to ensure
 		 * that we have gotten rid of all the system vnodes.


--- orig/sys/ufs/ufs/quota.h
+++ mod/sys/ufs/ufs/quota.h
@@ -117,6 +117,7 @@
 struct dquot {
 	LIST_ENTRY(dquot) dq_hash;	/* hash list */
 	TAILQ_ENTRY(dquot) dq_freelist;	/* free list */
+	struct mtx dq_lock;		/* lock for concurrency */
 	u_int16_t dq_flags;		/* flags, see below */
 	u_int16_t dq_type;		/* quota type of this dquot */
 	u_int32_t dq_cnt;		/* count of active references */


--- orig/sys/ufs/ufs/ufs_inode.c
+++ mod/sys/ufs/ufs/ufs_inode.c
@@ -143,6 +143,7 @@
 	struct ufsmount *ump = ip->i_ump;
 #ifdef QUOTA
 	int i;
+	struct dquot *dq;
 #endif
 
 	if (prtactive && vp->v_usecount != 0)
@@ -165,8 +166,11 @@
 #ifdef QUOTA
 	for (i = 0; i < MAXQUOTAS; i++) {
 		if (ip->i_dquot[i] != NODQUOT) {
-			dqrele(vp, ip->i_dquot[i]);
+			VI_LOCK(vp);
+			dq = ip->i_dquot[i];
 			ip->i_dquot[i] = NODQUOT;
+			VI_UNLOCK(vp);
+			dqrele(vp, dq);
 		}
 	}
 #endif


--- orig/sys/ufs/ufs/ufs_quota.c
+++ mod/sys/ufs/ufs/ufs_quota.c
@@ -102,8 +102,7 @@
 	 * Set up the user quota based on file uid.
 	 * EINVAL means that quotas are not enabled.
 	 */
-	if (ip->i_dquot[USRQUOTA] == NODQUOT &&
-	    (error =
+	if ((error =
 		dqget(vp, ip->i_uid, ump, USRQUOTA, &ip->i_dquot[USRQUOTA])) &&
 	    error != EINVAL)
 		return (error);
@@ -111,8 +110,7 @@
 	 * Set up the group quota based on file gid.
 	 * EINVAL means that quotas are not enabled.
 	 */
-	if (ip->i_dquot[GRPQUOTA] == NODQUOT &&
-	    (error =
+	if ((error =
 		dqget(vp, ip->i_gid, ump, GRPQUOTA, &ip->i_dquot[GRPQUOTA])) &&
 	    error != EINVAL)
 		return (error);
@@ -143,9 +141,10 @@
 		for (i = 0; i < MAXQUOTAS; i++) {
 			if ((dq = ip->i_dquot[i]) == NODQUOT)
 				continue;
+			mtx_lock(&(dq->dq_lock));
 			while (dq->dq_flags & DQ_LOCK) {
 				dq->dq_flags |= DQ_WANT;
-				(void) tsleep(dq, PINOD+1, "chkdq1", 0);
+				(void) msleep(dq, &(dq->dq_lock), PINOD+1, "chkdq1", 0);
 			}
 			ncurblocks = dq->dq_curblocks + change;
 			if (ncurblocks >= 0)
@@ -154,6 +153,7 @@
 				dq->dq_curblocks = 0;
 			dq->dq_flags &= ~DQ_BLKS;
 			dq->dq_flags |= DQ_MOD;
+			mtx_unlock(&(dq->dq_lock));
 		}
 		return (0);
 	}
@@ -169,9 +169,10 @@
 	for (i = 0; i < MAXQUOTAS; i++) {
 		if ((dq = ip->i_dquot[i]) == NODQUOT)
 			continue;
+		mtx_lock(&(dq->dq_lock));
 		while (dq->dq_flags & DQ_LOCK) {
 			dq->dq_flags |= DQ_WANT;
-			(void) tsleep(dq, PINOD+1, "chkdq2", 0);
+			(void) msleep(dq, &(dq->dq_lock), PINOD+1, "chkdq2", 0);
 		}
 		/* Reset timer when crossing soft limit */
 		if (dq->dq_curblocks + change >= dq->dq_bsoftlimit &&
@@ -180,6 +181,7 @@
 			    VFSTOUFS(ITOV(ip)->v_mount)->um_btime[i];
 		dq->dq_curblocks += change;
 		dq->dq_flags |= DQ_MOD;
+		mtx_unlock(&(dq->dq_lock));
 	}
 	return (0);
 }
@@ -197,6 +199,9 @@
 {
 	struct dquot *dq = ip->i_dquot[type];
 	ufs2_daddr_t ncurblocks = dq->dq_curblocks + change;
+	int unlocked = 0;
+
+	mtx_lock(&(dq->dq_lock));
 
 	/*
 	 * If user would exceed their hard limit, disallow space allocation.
@@ -204,11 +209,15 @@
 	if (ncurblocks >= dq->dq_bhardlimit && dq->dq_bhardlimit) {
 		if ((dq->dq_flags & DQ_BLKS) == 0 &&
 		    ip->i_uid == cred->cr_uid) {
+			dq->dq_flags |= DQ_BLKS;
+			mtx_unlock(&(dq->dq_lock));
+			unlocked = 1;
 			uprintf("\n%s: write failed, %s disk limit reached\n",
 			    ITOV(ip)->v_mount->mnt_stat.f_mntonname,
 			    quotatypes[type]);
-			dq->dq_flags |= DQ_BLKS;
 		}
+		if (!unlocked)
+			mtx_unlock(&(dq->dq_lock));
 		return (EDQUOT);
 	}
 	/*
@@ -219,6 +228,7 @@
 		if (dq->dq_curblocks < dq->dq_bsoftlimit) {
 			dq->dq_btime = time_second +
 			    VFSTOUFS(ITOV(ip)->v_mount)->um_btime[type];
+			mtx_unlock(&(dq->dq_lock));
 			if (ip->i_uid == cred->cr_uid)
 				uprintf("\n%s: warning, %s %s\n",
 				    ITOV(ip)->v_mount->mnt_stat.f_mntonname,
@@ -228,15 +238,20 @@
 		if (time_second > dq->dq_btime) {
 			if ((dq->dq_flags & DQ_BLKS) == 0 &&
 			    ip->i_uid == cred->cr_uid) {
+				dq->dq_flags |= DQ_BLKS;
+				mtx_unlock(&(dq->dq_lock));
+				unlocked = 1;
 				uprintf("\n%s: write failed, %s %s\n",
 				    ITOV(ip)->v_mount->mnt_stat.f_mntonname,
 				    quotatypes[type],
 				    "disk quota exceeded for too long");
-				dq->dq_flags |= DQ_BLKS;
 			}
+			if (!unlocked)
+				mtx_unlock(&(dq->dq_lock));
 			return (EDQUOT);
 		}
 	}
+	mtx_unlock(&(dq->dq_lock));
 	return (0);
 }
 
@@ -265,9 +280,10 @@
 		for (i = 0; i < MAXQUOTAS; i++) {
 			if ((dq = ip->i_dquot[i]) == NODQUOT)
 				continue;
+			mtx_lock(&(dq->dq_lock));
 			while (dq->dq_flags & DQ_LOCK) {
 				dq->dq_flags |= DQ_WANT;
-				(void) tsleep(dq, PINOD+1, "chkiq1", 0);
+				(void) msleep(dq, &(dq->dq_lock), PINOD+1, "chkiq1", 0);
 			}
 			ncurinodes = dq->dq_curinodes + change;
 			/* XXX: ncurinodes is unsigned */
@@ -277,6 +293,7 @@
 				dq->dq_curinodes = 0;
 			dq->dq_flags &= ~DQ_INODS;
 			dq->dq_flags |= DQ_MOD;
+			mtx_unlock(&(dq->dq_lock));
 		}
 		return (0);
 	}
@@ -292,9 +309,10 @@
 	for (i = 0; i < MAXQUOTAS; i++) {
 		if ((dq = ip->i_dquot[i]) == NODQUOT)
 			continue;
+		mtx_lock(&(dq->dq_lock));
 		while (dq->dq_flags & DQ_LOCK) {
 			dq->dq_flags |= DQ_WANT;
-			(void) tsleep(dq, PINOD+1, "chkiq2", 0);
+			(void) msleep(dq, &(dq->dq_lock), PINOD+1, "chkiq2", 0);
 		}
 		/* Reset timer when crossing soft limit */
 		if (dq->dq_curinodes + change >= dq->dq_isoftlimit &&
@@ -303,6 +321,7 @@
 			    VFSTOUFS(ITOV(ip)->v_mount)->um_itime[i];
 		dq->dq_curinodes += change;
 		dq->dq_flags |= DQ_MOD;
+		mtx_unlock(&(dq->dq_lock));
 	}
 	return (0);
 }
@@ -320,18 +339,24 @@
 {
 	struct dquot *dq = ip->i_dquot[type];
 	ino_t ncurinodes = dq->dq_curinodes + change;
+	int unlocked = 0;
 
+	mtx_lock(&(dq->dq_lock));
 	/*
 	 * If user would exceed their hard limit, disallow inode allocation.
 	 */
 	if (ncurinodes >= dq->dq_ihardlimit && dq->dq_ihardlimit) {
 		if ((dq->dq_flags & DQ_INODS) == 0 &&
 		    ip->i_uid == cred->cr_uid) {
+			dq->dq_flags |= DQ_INODS;
+			mtx_unlock(&(dq->dq_lock));
+			unlocked = 1;
 			uprintf("\n%s: write failed, %s inode limit reached\n",
 			    ITOV(ip)->v_mount->mnt_stat.f_mntonname,
 			    quotatypes[type]);
-			dq->dq_flags |= DQ_INODS;
 		}
+		if (!unlocked)
+			mtx_unlock(&(dq->dq_lock));
 		return (EDQUOT);
 	}
 	/*
@@ -342,6 +367,7 @@
 		if (dq->dq_curinodes < dq->dq_isoftlimit) {
 			dq->dq_itime = time_second +
 			    VFSTOUFS(ITOV(ip)->v_mount)->um_itime[type];
+			mtx_unlock(&(dq->dq_lock));
 			if (ip->i_uid == cred->cr_uid)
 				uprintf("\n%s: warning, %s %s\n",
 				    ITOV(ip)->v_mount->mnt_stat.f_mntonname,
@@ -351,15 +377,20 @@
 		if (time_second > dq->dq_itime) {
 			if ((dq->dq_flags & DQ_INODS) == 0 &&
 			    ip->i_uid == cred->cr_uid) {
+				dq->dq_flags |= DQ_INODS;
+				mtx_unlock(&(dq->dq_lock));
+				unlocked = 1;
 				uprintf("\n%s: write failed, %s %s\n",
 				    ITOV(ip)->v_mount->mnt_stat.f_mntonname,
 				    quotatypes[type],
 				    "inode quota exceeded for too long");
-				dq->dq_flags |= DQ_INODS;
 			}
+			if (!unlocked)
+				mtx_unlock(&(dq->dq_lock));
 			return (EDQUOT);
 		}
 	}
+	mtx_unlock(&(dq->dq_lock));
 	return (0);
 }
 
@@ -375,15 +406,18 @@
 	struct ufsmount *ump = VFSTOUFS(ITOV(ip)->v_mount);
 	int i;
 
+	mtx_lock(&(ump->um_lock));
 	for (i = 0; i < MAXQUOTAS; i++) {
 		if (ump->um_quotas[i] == NULLVP ||
 		    (ump->um_qflags[i] & (QTF_OPENING|QTF_CLOSING)))
 			continue;
 		if (ip->i_dquot[i] == NODQUOT) {
+			mtx_unlock(&(ump->um_lock));
 			vprint("chkdquot: missing dquot", ITOV(ip));
 			panic("chkdquot: missing dquot");
 		}
 	}
+	mtx_unlock(&(ump->um_lock));
 }
 #endif
 
@@ -404,10 +438,12 @@
 	struct ufsmount *ump = VFSTOUFS(mp);
 	struct vnode *vp, **vpp;
 	struct vnode *mvp;
-	struct dquot *dq;
+	struct dquot *dq = NODQUOT;
 	int error, flags;
 	struct nameidata nd;
 
+	GIANT_REQUIRED;
+
 	error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
 	if (error)
 		return (error);
@@ -500,13 +536,19 @@
 	struct inode *ip;
 	int error;
 
+	GIANT_REQUIRED;
+
 	error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
 	if (error)
 		return (error);
 
-	if ((qvp = ump->um_quotas[type]) == NULLVP)
+	mtx_lock(&(ump->um_lock));
+	if ((qvp = ump->um_quotas[type]) == NULLVP) {
+		mtx_unlock(&(ump->um_lock));
 		return (0);
+	}
 	ump->um_qflags[type] |= QTF_CLOSING;
+	mtx_unlock(&(ump->um_lock));
 	/*
 	 * Search vnodes associated with this mount point,
 	 * deleting any references to quota file being closed.
@@ -527,8 +569,10 @@
 			goto again;
 		}
 		ip = VTOI(vp);
+		VI_LOCK(vp);
 		dq = ip->i_dquot[type];
 		ip->i_dquot[type] = NODQUOT;
+		VI_UNLOCK(vp);
 		dqrele(vp, dq);
 		VOP_UNLOCK(vp, 0, td);
 		vrele(vp);
@@ -540,13 +584,15 @@
 	qvp->v_vflag &= ~VV_SYSTEM;
 	VOP_UNLOCK(qvp, 0, td);
 	error = vn_close(qvp, FREAD|FWRITE, td->td_ucred, td);
-	ump->um_quotas[type] = NULLVP;
 	crfree(ump->um_cred[type]);
 	ump->um_cred[type] = NOCRED;
+	mtx_lock(&(ump->um_lock));
 	ump->um_qflags[type] &= ~QTF_CLOSING;
+	ump->um_quotas[type] = NULLVP;
 	for (type = 0; type < MAXQUOTAS; type++)
 		if (ump->um_quotas[type] != NULLVP)
 			break;
+	mtx_unlock(&(ump->um_lock));
 	if (type == MAXQUOTAS)
 		mp->mnt_flag &= ~MNT_QUOTA;
 	return (error);
@@ -563,9 +609,11 @@
 	int type;
 	void *addr;
 {
-	struct dquot *dq;
+	struct dquot *dq = NODQUOT;
 	int error;
 
+	GIANT_REQUIRED;
+
 	switch (type) {
 	case USRQUOTA:
 		if ((td->td_ucred->cr_uid != id) && !unprivileged_get_quota) {
@@ -607,11 +655,13 @@
 	void *addr;
 {
 	struct dquot *dq;
-	struct dquot *ndq;
+	struct dquot *ndq = NODQUOT;
 	struct ufsmount *ump = VFSTOUFS(mp);
 	struct dqblk newlim;
 	int error;
 
+	GIANT_REQUIRED;
+
 	error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
 	if (error)
 		return (error);
@@ -623,9 +673,10 @@
 	if (error)
 		return (error);
 	dq = ndq;
+	mtx_lock(&(dq->dq_lock));
 	while (dq->dq_flags & DQ_LOCK) {
 		dq->dq_flags |= DQ_WANT;
-		(void) tsleep(dq, PINOD+1, "setqta", 0);
+		(void) msleep(dq, &(dq->dq_lock), PINOD+1, "setqta", 0);
 	}
 	/*
 	 * Copy all but the current values.
@@ -657,6 +708,7 @@
 	else
 		dq->dq_flags &= ~DQ_FAKE;
 	dq->dq_flags |= DQ_MOD;
+	mtx_unlock(&(dq->dq_lock));
 	dqrele(NULLVP, dq);
 	return (0);
 }
@@ -674,10 +726,12 @@
 {
 	struct dquot *dq;
 	struct ufsmount *ump = VFSTOUFS(mp);
-	struct dquot *ndq;
+	struct dquot *ndq = NODQUOT;
 	struct dqblk usage;
 	int error;
 
+	GIANT_REQUIRED;
+
 	error = suser_cred(td->td_ucred, SUSER_ALLOWJAIL);
 	if (error)
 		return (error);
@@ -689,9 +743,10 @@
 	if (error)
 		return (error);
 	dq = ndq;
+	mtx_lock(&(dq->dq_lock));
 	while (dq->dq_flags & DQ_LOCK) {
 		dq->dq_flags |= DQ_WANT;
-		(void) tsleep(dq, PINOD+1, "setuse", 0);
+		(void) msleep(dq, &(dq->dq_lock), PINOD+1, "setuse", 0);
 	}
 	/*
 	 * Reset time limit if have a soft limit and were
@@ -710,6 +765,7 @@
 	if (dq->dq_curinodes < dq->dq_isoftlimit)
 		dq->dq_flags &= ~DQ_INODS;
 	dq->dq_flags |= DQ_MOD;
+	mtx_unlock(&(dq->dq_lock));
 	dqrele(NULLVP, dq);
 	return (0);
 }
@@ -727,13 +783,17 @@
 	struct dquot *dq;
 	int i, error;
 
+	GIANT_REQUIRED;
+
 	/*
 	 * Check if the mount point has any quotas.
 	 * If not, simply return.
 	 */
+	mtx_lock(&(ump->um_lock));
 	for (i = 0; i < MAXQUOTAS; i++)
 		if (ump->um_quotas[i] != NULLVP)
 			break;
+	mtx_unlock(&(ump->um_lock));
 	if (i == MAXQUOTAS)
 		return (0);
 	/*
@@ -761,7 +821,7 @@
 		}
 		for (i = 0; i < MAXQUOTAS; i++) {
 			dq = VTOI(vp)->i_dquot[i];
-			if (dq != NODQUOT && (dq->dq_flags & DQ_MOD))
+			if (dq != NODQUOT)
 				dqsync(vp, dq);
 		}
 		vput(vp);
@@ -786,6 +846,12 @@
 static TAILQ_HEAD(dqfreelist, dquot) dqfreelist;
 static long numdquot, desireddquot = DQUOTINC;
 
+/* 
+ * Lock to protect quota hash, dq free list and dq_cnt ref counters of
+ * _all_ dqs.
+ */
+struct mtx dqhlock;
+
 /*
  * Initialize the quota system.
  */
@@ -793,6 +859,7 @@
 dqinit()
 {
 
+	mtx_init(&dqhlock, "dqhlock", NULL, MTX_DEF);
 	dqhashtbl = hashinit(desiredvnodes, M_DQUOT, &dqhash);
 	TAILQ_INIT(&dqfreelist);
 }
@@ -808,8 +875,10 @@
 	hashdestroy(dqhashtbl, M_DQUOT, dqhash);
 	while ((dq = TAILQ_FIRST(&dqfreelist)) != NULL) {
 		TAILQ_REMOVE(&dqfreelist, dq, dq_freelist);
+		mtx_destroy(&(dq->dq_lock));
 		free(dq, M_DQUOT);
 	}
+	mtx_destroy(&dqhlock);
 }
 
 /*
@@ -832,14 +901,27 @@
 	struct uio auio;
 	int error;
 
+	if (vp != NULLVP) {
+		VI_LOCK(vp);
+		if (*dqp != NODQUOT) {
+			VI_UNLOCK(vp);
+			return (0);
+		}
+		VI_UNLOCK(vp);
+	}
+
+	mtx_lock(&(ump->um_lock));
 	dqvp = ump->um_quotas[type];
 	if (dqvp == NULLVP || (ump->um_qflags[type] & QTF_CLOSING)) {
 		*dqp = NODQUOT;
+		mtx_unlock(&(ump->um_lock));
 		return (EINVAL);
 	}
+	mtx_unlock(&(ump->um_lock));
 	/*
 	 * Check the cache first.
 	 */
+	mtx_lock(&dqhlock);
 	dqh = DQHASH(dqvp, id);
 	LIST_FOREACH(dq, dqh, dq_hash) {
 		if (dq->dq_id != id ||
@@ -852,7 +934,19 @@
 		if (dq->dq_cnt == 0)
 			TAILQ_REMOVE(&dqfreelist, dq, dq_freelist);
 		DQREF(dq);
-		*dqp = dq;
+		mtx_unlock(&dqhlock);
+		if (vp == NULLVP)
+			*dqp = dq;
+		else {
+			VI_LOCK(vp);
+			if (*dqp == NODQUOT) {
+				*dqp = dq;
+				VI_UNLOCK(vp);
+			} else {
+				VI_UNLOCK(vp);
+				dqrele(vp, dq);
+			}
+		}
 		return (0);
 	}
 	/*
@@ -862,11 +956,14 @@
 	    numdquot < MAXQUOTAS * desiredvnodes)
 		desireddquot += DQUOTINC;
 	if (numdquot < desireddquot) {
+		mtx_unlock(&dqhlock);
 		dq = (struct dquot *)malloc(sizeof *dq, M_DQUOT,
 		    M_WAITOK | M_ZERO);
 		numdquot++;
+		mtx_init(&(dq->dq_lock), "dqlock", NULL, MTX_DEF);
 	} else {
 		if ((dq = TAILQ_FIRST(&dqfreelist)) == NULL) {
+			mtx_unlock(&dqhlock);
 			tablefull("dquot");
 			*dqp = NODQUOT;
 			return (EUSERS);
@@ -876,18 +973,22 @@
 		TAILQ_REMOVE(&dqfreelist, dq, dq_freelist);
 		if (dq->dq_ump != NULL)
 			LIST_REMOVE(dq, dq_hash);
+		mtx_unlock(&dqhlock);
 	}
 	/*
 	 * Initialize the contents of the dquot structure.
 	 */
 	if (vp != dqvp)
 		vn_lock(dqvp, LK_EXCLUSIVE | LK_RETRY, td);
-	LIST_INSERT_HEAD(dqh, dq, dq_hash);
-	DQREF(dq);
 	dq->dq_flags = DQ_LOCK;
 	dq->dq_id = id;
 	dq->dq_ump = ump;
 	dq->dq_type = type;
+	mtx_lock(&dqhlock);
+	LIST_INSERT_HEAD(dqh, dq, dq_hash);
+	DQREF(dq);
+	mtx_unlock(&dqhlock);
+
 	auio.uio_iov = &aiov;
 	auio.uio_iovcnt = 1;
 	aiov.iov_base = &dq->dq_dqb;
@@ -902,17 +1003,24 @@
 		bzero(&dq->dq_dqb, sizeof(struct dqblk));
 	if (vp != dqvp)
 		VOP_UNLOCK(dqvp, 0, td);
+	mtx_lock(&(dq->dq_lock));
 	if (dq->dq_flags & DQ_WANT)
 		wakeup(dq);
 	dq->dq_flags = 0;
+	mtx_unlock(&(dq->dq_lock));
 	/*
 	 * I/O error in reading quota file, release
 	 * quota structure and reflect problem to caller.
 	 */
 	if (error) {
+		mtx_lock(&dqhlock);
 		LIST_REMOVE(dq, dq_hash);
+		mtx_unlock(&dqhlock);
 		dqrele(vp, dq);
+		VI_LOCK(vp);
+		/* XXX ? */
 		*dqp = NODQUOT;
+		VI_UNLOCK(vp);
 		return (error);
 	}
 	/*
@@ -928,7 +1036,18 @@
 		if (dq->dq_itime == 0)
 			dq->dq_itime = time_second + ump->um_itime[type];
 	}
-	*dqp = dq;
+	if (vp == NULLVP)
+		*dqp = dq;
+	else {
+		VI_LOCK(vp);
+		if (*dqp == NODQUOT) {
+			*dqp = dq;
+			VI_UNLOCK(vp);
+		} else {
+			VI_UNLOCK(vp);
+			dqrele(vp, dq);
+		}
+	}
 	return (0);
 }
 
@@ -956,15 +1075,24 @@
 
 	if (dq == NODQUOT)
 		return;
+	mtx_lock(&dqhlock);
 	if (dq->dq_cnt > 1) {
 		dq->dq_cnt--;
+		mtx_unlock(&dqhlock);
 		return;
 	}
-	if (dq->dq_flags & DQ_MOD)
-		(void) dqsync(vp, dq);
+	mtx_unlock(&dqhlock);
+
+	(void) dqsync(vp, dq);
+
+	mtx_lock(&dqhlock);
 	if (--dq->dq_cnt > 0)
+	{
+		mtx_unlock(&dqhlock);
 		return;
+	}
 	TAILQ_INSERT_TAIL(&dqfreelist, dq, dq_freelist);
+	mtx_unlock(&dqhlock);
 }
 
 /*
@@ -983,23 +1111,26 @@
 
 	if (dq == NODQUOT)
 		panic("dqsync: dquot");
-	if ((dq->dq_flags & DQ_MOD) == 0)
-		return (0);
 	if ((dqvp = dq->dq_ump->um_quotas[dq->dq_type]) == NULLVP)
 		panic("dqsync: file");
 	(void) vn_write_suspend_wait(dqvp, NULL, V_WAIT);
 	if (vp != dqvp)
 		vn_lock(dqvp, LK_EXCLUSIVE | LK_RETRY, td);
+
+	mtx_lock(&(dq->dq_lock));
 	while (dq->dq_flags & DQ_LOCK) {
 		dq->dq_flags |= DQ_WANT;
-		(void) tsleep(dq, PINOD+2, "dqsync", 0);
-		if ((dq->dq_flags & DQ_MOD) == 0) {
-			if (vp != dqvp)
-				VOP_UNLOCK(dqvp, 0, td);
-			return (0);
-		}
+		(void) msleep(dq, &(dq->dq_lock), PINOD+2, "dqsync", 0);
+	}
+	if ((dq->dq_flags & DQ_MOD) == 0) {
+		mtx_unlock(&(dq->dq_lock));
+		if (vp != dqvp)
+			VOP_UNLOCK(dqvp, 0, td);
+		return (0);
 	}
 	dq->dq_flags |= DQ_LOCK;
+	mtx_unlock(&(dq->dq_lock));
+
 	auio.uio_iov = &aiov;
 	auio.uio_iovcnt = 1;
 	aiov.iov_base = &dq->dq_dqb;
@@ -1012,9 +1143,13 @@
 	error = VOP_WRITE(dqvp, &auio, 0, dq->dq_ump->um_cred[dq->dq_type]);
 	if (auio.uio_resid && error == 0)
 		error = EIO;
+
+	mtx_lock(&(dq->dq_lock));
 	if (dq->dq_flags & DQ_WANT)
 		wakeup(dq);
 	dq->dq_flags &= ~(DQ_MOD|DQ_LOCK|DQ_WANT);
+	mtx_unlock(&(dq->dq_lock));
+
 	if (vp != dqvp)
 		VOP_UNLOCK(dqvp, 0, td);
 	return (error);
@@ -1035,6 +1170,7 @@
 	 * file off their hash chains (they will eventually
 	 * fall off the head of the free list and be re-used).
 	 */
+	mtx_lock(&dqhlock);
 	for (dqh = &dqhashtbl[dqhash]; dqh >= dqhashtbl; dqh--) {
 		for (dq = LIST_FIRST(dqh); dq; dq = nextdq) {
 			nextdq = LIST_NEXT(dq, dq_hash);
@@ -1046,4 +1182,5 @@
 			dq->dq_ump = (struct ufsmount *)0;
 		}
 	}
+	mtx_unlock(&dqhlock);
 }


--- orig/sys/ufs/ufs/ufs_vnops.c
+++ mod/sys/ufs/ufs/ufs_vnops.c
@@ -647,6 +647,7 @@
 #ifdef QUOTA
 	int i;
 	ufs2_daddr_t change;
+	struct dquot *dq;
 #endif
 
 	if (uid == (uid_t)VNOVAL)
@@ -674,19 +675,28 @@
 	if ((error = getinoquota(ip)) != 0)
 		return (error);
 	if (ouid == uid) {
-		dqrele(vp, ip->i_dquot[USRQUOTA]);
+		VI_LOCK(vp);
+		dq = ip->i_dquot[USRQUOTA];
 		ip->i_dquot[USRQUOTA] = NODQUOT;
+		VI_UNLOCK(vp);
+		dqrele(vp, dq);
 	}
 	if (ogid == gid) {
-		dqrele(vp, ip->i_dquot[GRPQUOTA]);
+		VI_LOCK(vp);
+		dq = ip->i_dquot[GRPQUOTA];
 		ip->i_dquot[GRPQUOTA] = NODQUOT;
+		VI_UNLOCK(vp);
+		dqrele(vp, dq);
 	}
 	change = DIP(ip, i_blocks);
 	(void) chkdq(ip, -change, cred, CHOWN);
 	(void) chkiq(ip, -1, cred, CHOWN);
 	for (i = 0; i < MAXQUOTAS; i++) {
-		dqrele(vp, ip->i_dquot[i]);
+		VI_LOCK(vp);
+		dq = ip->i_dquot[i];
 		ip->i_dquot[i] = NODQUOT;
+		VI_UNLOCK(vp);
+		dqrele(vp, dq);
 	}
 #endif
 	ip->i_gid = gid;
@@ -696,12 +706,18 @@
 #ifdef QUOTA
 	if ((error = getinoquota(ip)) == 0) {
 		if (ouid == uid) {
-			dqrele(vp, ip->i_dquot[USRQUOTA]);
+			VI_LOCK(vp);
+			dq = ip->i_dquot[USRQUOTA];
 			ip->i_dquot[USRQUOTA] = NODQUOT;
+			VI_UNLOCK(vp);
+			dqrele(vp, dq);
 		}
 		if (ogid == gid) {
-			dqrele(vp, ip->i_dquot[GRPQUOTA]);
+			VI_LOCK(vp);
+			dq = ip->i_dquot[GRPQUOTA];
 			ip->i_dquot[GRPQUOTA] = NODQUOT;
+			VI_UNLOCK(vp);
+			dqrele(vp, dq);
 		}
 		if ((error = chkdq(ip, change, cred, CHOWN)) == 0) {
 			if ((error = chkiq(ip, 1, cred, CHOWN)) == 0)
@@ -710,8 +726,11 @@
 				(void) chkdq(ip, -change, cred, CHOWN|FORCE);
 		}
 		for (i = 0; i < MAXQUOTAS; i++) {
-			dqrele(vp, ip->i_dquot[i]);
+			VI_LOCK(vp);
+			dq = ip->i_dquot[i];
 			ip->i_dquot[i] = NODQUOT;
+			VI_UNLOCK(vp);
+			dqrele(vp, dq);
 		}
 	}
 	ip->i_gid = ogid;
@@ -720,12 +739,18 @@
 	DIP_SET(ip, i_uid, ouid);
 	if (getinoquota(ip) == 0) {
 		if (ouid == uid) {
-			dqrele(vp, ip->i_dquot[USRQUOTA]);
+			VI_LOCK(vp);
+			dq = ip->i_dquot[USRQUOTA];
 			ip->i_dquot[USRQUOTA] = NODQUOT;
+			VI_UNLOCK(vp);
+			dqrele(vp, dq);
 		}
 		if (ogid == gid) {
-			dqrele(vp, ip->i_dquot[GRPQUOTA]);
+			VI_LOCK(vp);
+			dq = ip->i_dquot[GRPQUOTA];
 			ip->i_dquot[GRPQUOTA] = NODQUOT;
+			VI_UNLOCK(vp);
+			dqrele(vp, dq);
 		}
 		(void) chkdq(ip, change, cred, FORCE|CHOWN);
 		(void) chkiq(ip, 1, cred, FORCE|CHOWN);



